`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 		 SCIPP
// Engineer:		 Kunal Arya
//
// Create Date:    11:20:34 05/10/05
// Design Name:    Basic Counter
// Module Name:    top
// Target Device:  Spartan - xc2s200e-6, also called xc2v200
// Tool versions:  ISE 7.1
// Description:	 Instantiates basic counter for output on the 
//						 Digilent DE2 with the DIO1 expansion
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module top(
  	clock,  // Input, global clock
	reset,  // Input, active-high reset
	value	  // Output, 8-bit value of the counter
);

    input clock;
    input reset;
    output [0:7] value;

	 reg [24:0] clkdiv_count;

	 // Divide the clock
	 always @(posedge clock ) begin
	 	clkdiv_count = clkdiv_count + 1;
	 end

	 // choosing 24 here yields a 2.98 Hz clock
	 wire divided_clock = clkdiv_count[22];

 	 // Create and instantiate the counter
	 basic_counter counter0 (
	 	.clock( divided_clock ),
	 	.reset( reset ),
		.counter_value( value )
	 );

endmodule
